package com.zcloud.controller.offduty;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.offduty.OffDutyService;
import com.zcloud.service.system.DepartmentService;
import com.zcloud.service.system.UsersService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：休假
 * 作者：luoxiaobao
 * 时间：2021-06-11
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/offduty")
public class OffDutyController extends BaseController {

	@Autowired
	private OffDutyService offdutyService;
	@Autowired
	private UsersService usersService;
	@Autowired
	private DepartmentService departmentService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions("offduty:add")
	@ResponseBody
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OFFDUTY_ID", this.get32UUID());	//主键
		pd.put("ISDELETE", "0");	//是否删除 0 未删除  1已删除
		pd.put("OPERATOR", Jurisdiction.getUSER_ID());	//操作人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//操作时间
		pd.put("CREATOR", Jurisdiction.getUSER_ID());	//创建人
		pd.put("CREATTIME", DateUtil.date2Str(new Date()));	//创建时间
		offdutyService.save(pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("offduty:del")
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		offdutyService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("offduty:edit")
	@ResponseBody
	@LogAnno(menuType= "双重预防",menuServer= "离岗管理",instructionsOperate = "离岗管理",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUSER_ID());	//操作人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//操作时间
		offdutyService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("offduty:list")
	@ResponseBody
	@LogAnno(menuType= "双重预防",menuServer= "离岗管理",instructionsOperate = "离岗管理",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		PageData npd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))npd.put("KEYWORDS", KEYWORDS.trim());
		npd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		npd.put("DEPARTMENT_ID", Jurisdiction.getDEPARTMENT_ID());
		if ("show".equals(pd.getString("TYPE"))) {
			npd.put("ISMAIN", Jurisdiction.getIS_MAIN());
			npd.put("ISSUPERVISE", Jurisdiction.getISSUPERVISE());
		}
		String DEPTIDS = pd.getString("DEPTIDS");
		if(Tools.notEmpty(DEPTIDS)) {
			String DEPT_IDS[] = DEPTIDS.split(",");
			npd.put("DEPT_IDS", DEPT_IDS);
		}
		pd.put("USER_ID",Jurisdiction.getUSER_ID());
		PageData cpd = new PageData();
		cpd = usersService.findById(pd);
		npd.put("ISLEADER", cpd.getString("ISLEADER"));
		if(cpd.getString("ISLEADER") != null && cpd.getString("ISLEADER").equals("1")){
			String DEPARTMENT_ID = npd.getString("DEPARTMENT_ID");
			String ids = departmentService.getDEPARTMENT_IDS(DEPARTMENT_ID);
			ids=npd.getString("DEPARTMENT_ID")+","+ids;   //把自己部门插入进去
			if(ids!=null && Tools.notEmpty(ids)&& ids.lastIndexOf(",")>-1) {
				ids = ids.substring(0,ids.lastIndexOf(","));
				npd.put("DEPARTMENT_IDS", ids.split(","));
			}else {
				npd.put("DEPARTMENT_IDS", DEPARTMENT_ID);
			}
		}else {
			if(npd.getString("ISMAIN") != null && npd.getString("ISMAIN").equals("0")){
				npd.put("USER_ID",Jurisdiction.getUSER_ID());
			}
		}
		npd.put("TYPE",pd.getString("TYPE"));
		npd.put("STARTTIME",pd.getString("STARTTIME"));
		npd.put("ENDTIME",pd.getString("ENDTIME"));
		npd.put("REVIEW_STATUS",pd.getString("REVIEW_STATUS"));
		npd.put("REVIEW_USER_NAME",pd.getString("REVIEW_USER_NAME"));
		page.setPd(npd);
		List<PageData>	varList = offdutyService.list(page);	//列出OffDuty列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("offduty:edit")
	@ResponseBody
	@LogAnno(menuType= "双重预防",menuServer= "离岗管理",instructionsOperate = "离岗管理",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = offdutyService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("offduty:del")
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			offdutyService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("用户");	//1
		titles.add("公司");	//2
		titles.add("开始时间");	//3
		titles.add("结束时间");	//4
		titles.add("休班原因");	//5
		titles.add("删除状态 0 -未删除  1- 已删除");	//6
		titles.add("添加人");	//7
		titles.add("创建时间");	//8
		titles.add("修改人");	//9
		titles.add("修改时间");	//10
		dataMap.put("titles", titles);
		List<PageData> varOList = offdutyService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("USER_ID"));	    //1
			vpd.put("var2", varOList.get(i).getString("CORPINFO_ID"));	    //2
			vpd.put("var3", varOList.get(i).getString("STARTTIME"));	    //3
			vpd.put("var4", varOList.get(i).getString("ENDTIME"));	    //4
			vpd.put("var5", varOList.get(i).getString("DESCR"));	    //5
			vpd.put("var6", varOList.get(i).getString("ISDELETE"));	    //6
			vpd.put("var7", varOList.get(i).getString("CREATOR"));	    //7
			vpd.put("var8", varOList.get(i).getString("CREATTIME"));	    //8
			vpd.put("var9", varOList.get(i).getString("OPERATOR"));	    //9
			vpd.put("var10", varOList.get(i).getString("OPERATTIME"));	    //10
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

	/** 审批离岗申请
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/review")
	// @RequiresPermissions("offduty:edit")
	@ResponseBody
	@LogAnno(menuType= "双重预防",menuServer= "离岗管理",instructionsOperate = "离岗管理",instructionsType = "审批")
	public Object review() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUSER_ID());	//操作人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//操作时间
		offdutyService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

	/** 取消离岗申请
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/cancel")
	// @RequiresPermissions("offduty:edit")
	@ResponseBody
	@LogAnno(menuType= "双重预防",menuServer= "离岗管理",instructionsOperate = "离岗管理",instructionsType = "取消")
	public Object cancel() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("ISDELETE", "1");	//是否删除 0 未删除  1已删除
		pd.put("OPERATOR", Jurisdiction.getUSER_ID());	//操作人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//操作时间
		offdutyService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

}
